    <?php
      defined('BASEPATH') OR exit('No direct script access allowed');

      class Image extends CI_Controller {
            public function __construct()
            {
                parent::__construct();
                $this->load->helper(array('form', 'url'));
                $this->load->library('form_validation', 'image_lib');
            }

            public function index()
            {
              $this->load->view('image', array('error' => ' ' ));
            }
            public function upload_file()
            {
                    $config['upload_path']          = './files/';
                    $config['allowed_types']        = 'gif|jpg|jpeg|png';
                    $config['max_size']             = 500;
                    $config['max_width']            = 1024;
                    $config['max_height']           = 768;
                    $this->load->library('upload', $config);

                    if ( ! $this->upload->do_upload('userimage'))
                    {    
                        
                        $this->form_validation->set_error_delimiters('<p class="error">', '</p>');
                        $error = array('error' => $this->upload->display_errors());
                        $this->load->view('image', $error);
                    }
                    else
                    {
                        $data = array('upload_data' => $this->upload->data());
                        $file_name = $data['upload_data']['file_name'];
                        
                        //Resize Image code
                        $imgConfig = array();
                        $imgConfig['image_library']  = 'gd2';
                        $imgConfig['source_image']   = './files/'.$file_name;
                        $imgConfig['create_thumb']     = FALSE;
                        $imgConfig['maintain_ratio']   = TRUE;
                        $imgConfig['new_image']     = './files/res_'.$file_name;
                        $imgConfig['width']            = 150;
                        $imgConfig['height']           = 75;   
                        $this->load->library('image_lib', $imgConfig);
                                               
                        if (!$this->image_lib->resize()){  
                            echo $this->image_lib->display_errors();
                        } 

                        //Create Thumbnail
                        $config['image_library']  = 'gd2';
                        $config['source_image']   = './files/'.$file_name;
                        $config['create_thumb']   = TRUE;
                        $config['maintain_ratio'] = TRUE;
                        $config['width']          = 75;
                        $config['height']         = 50;
                        $this->load->library('image_lib', $config);
                        $this->image_lib->resize(); 
                        
                        //crop andimage
                        $imgConfig = array();
                        $imgConfig['image_library']= 'gd2';
                        $imgConfig['source_image'] = './files/'.$file_name;
                        $imgConfig['new_image']    = './files/crop_'.$file_name;
                        $imgConfig['height'] = '300';
                        $imgConfig['width']  = '200';
                        $imgConfig['x_axis'] = '150';
                        $imgConfig['y_axis'] = '150';
                        $this->load->library('image_lib', $imgConfig);
                        $this->image_lib->initialize($imgConfig); 

                        if ( ! $this->image_lib->crop()){
                            echo $this->image_lib->display_errors();
                        } 

                        //rotate an image using codeigniter 
                        $imgConfig = array();
                        $imgConfig['image_library']  = 'gd2';
                        $imgConfig['source_image']   = './files/'.$file_name;
                        $imgConfig['height'] = '400';
                        $imgConfig['width']  = '400';
                        $imgConfig['rotation_angle'] = '90';
                        $imgConfig['new_image']      = './files/rot_'.$file_name;
                        $this->load->library('image_lib', $imgConfig);
                        $this->image_lib->initialize($imgConfig);

                        if ( ! $this->image_lib->rotate()){
                            echo $this->image_lib->display_errors();
                        } 

                        //Text watermark image
                        $imgConfig = array();
                        $imgConfig['image_library'] = 'GD2';
                        $imgConfig['source_image']  = './files/'.$file_name;
                        $imgConfig['new_image'] = './files/wm_text_'.$file_name;
                        $imgConfig['wm_text'] = 'Copyright 2016 - Programmer Blog';
                        $imgConfig['wm_type'] = 'text';
                        $imgConfig['wm_font_size']     = '16';
                    
                        $this->load->library('image_lib', $imgConfig);
                        $this->image_lib->initialize($imgConfig);
                        $this->image_lib->watermark(); 
                    
                        //Overlay watermark image
                        $imgConfig = array();
                        $imgConfig['image_library'] = 'GD2';
                        $imgConfig['source_image'] = './files/'.$file_name;
                        $imgConfig['wm_overlay_path'] = './files/overlay_pb.png';
                        $imgConfig['wm_type'] = 'overlay';
                        $this->load->library('image_lib', $imgConfig);
                        $this->image_lib->initialize($imgConfig);
                        $this->image_lib->watermark();  

                        $this->load->view('success', $data);

                        
                    }
            }
    }